config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { omniauth_callbacks: "users/omniauth_callbacks" }

  # Hoptoad Notifier Routes
  match '/notifier_api/v2/notices' => 'notices#create', via: [:get, :post]
  get '/locate/:id' => 'notices#locate', :as => :locate
  get '/notices/:id' => 'notices#show_by_id', :as => :show_notice_by_id

  resources :notices, only: [:show]
  resources :users do
    member do
      delete :unlink_github
      delete :unlink_google
    end
  end

  resources :site_config, only: [:index] do
    collection do
      put :update
    end
  end

  resources :problems, only: [:index] do
    collection do
      post :destroy_several
      post :resolve_several
      post :unresolve_several
      post :merge_several
      post :unmerge_several
      get :search
    end
  end

  resources :apps do
    resources :problems do
      resources :notices
      resources :comments, only: [:create, :destroy]

      collection do
        post :destroy_all
      end

      member do
        get :xhr_sparkline
        put :resolve
        put :unresolve
        post :create_issue
        post :close_issue
        delete :unlink_issue
      end
    end
    resources :watchers, only: [:destroy, :update]
    member do
      post :regenerate_api_key
    end
    collection do
      get :search
    end
  end

  get 'problems/:id' => 'problems#show_by_id'

  get 'health/readiness' => 'health#readiness'
  get 'health/liveness' => 'health#liveness'
  get 'health/api-key-tester' => 'health#api_key_tester'

  namespace :api do
    namespace :v1 do
      resources :problems, only: [:index, :show], defaults: { format: 'json' }
      resources :notices,  only: [:index], defaults: { format: 'json' }
      resources :stats, only: [], defaults: { format: 'json' } do
        collection do
          get :app
        end
      end
    end
  end

  match '/api/v3/projects/:project_id/create-notice' => 'api/v3/notices#create', via: [:post]
  match '/api/v3/projects/:project_id/notices' => 'api/v3/notices#create', via: [:post, :options]

  root to: 'apps#index'
end

app/controllers/api/v1/problems_controller.rb
class Api::V1::ProblemsController < ApplicationController
  respond_to :json, :xml
  FIELDS = %w(_id app_id app_name environment message where first_notice_at last_notice_at resolved resolved_at notices_count)

  def show
    result = benchmark("[api/v1/problems_controller/show] query time") do
      begin
        Problem.only(FIELDS).find(params[:id])
      rescue Mongoid::Errors::DocumentNotFound
        head :not_found
        return false
      end
    end

    respond_to do |format|
      format.any(:html, :json) { render json: result } # render JSON if no extension specified on path
      format.xml { render xml: result }
    end
  end

  def index
    query = {}

    if params.key?(:start_date) && params.key?(:end_date)
      start_date = Time.parse(params[:start_date]).utc
      end_date = Time.parse(params[:end_date]).utc
      query = { :first_notice_at => { "$lte" => end_date }, "$or" => [{ resolved_at: nil }, { resolved_at: { "$gte" => start_date } }] }
    end

    results = benchmark("[api/v1/problems_controller/index] query time") do
      Problem.where(query).with(consistency: :strong).only(FIELDS).to_a
    end

    respond_to do |format|
      format.any(:html, :json) { render json: JSON.dump(results) } # render JSON if no extension specified on path
      format.xml { render xml: results }
    end
  end
end

app/controllers/problems_controller.rb
require 'sparklines'

class ProblemsController < ApplicationController
  include ProblemsSearcher

  before_action :need_selected_problem, only: [
    :resolve_several, :unresolve_several, :unmerge_several
  ]

  expose(:app_scope) do
    params[:app_id] ? App.where(_id: params[:app_id]) : App.all
  end

  expose(:app) do
    AppDecorator.new app_scope.find(params[:app_id])
  end

  expose(:problem) do
    ProblemDecorator.new app.problems.find(params[:id])
  end

  expose(:all_errs) do
    params[:all_errs]
  end

  expose(:filter) do
    params[:filter]
  end

  expose(:params_environement) do
    params[:environment]
  end

  # to use with_app_exclusions, hit a path like /problems?filter=-app:noisy_app%20-app:another_noisy_app
  # it would be possible to add a really fancy UI for it at some point, but for now, it's really
  # useful if there are noisy apps that you want to ignore.
  expose(:problems) do
    finder = Problem.
      for_apps(app_scope).
      in_env(params_environement).
      filtered(filter).
      all_else_unresolved(all_errs).
      ordered_by(params_sort, params_order)

    finder = finder.search(params[:search]) if params[:search].present?
    finder.page(params[:page]).per(current_user.per_page)
  end

  def index; end

  def show
    notice =
      if params[:notice_id]
        Notice.find(params[:notice_id])
      else
        @notices = problem.object.notices.reverse_ordered.
          page(params[:notice]).per(1)
        @notices.first
      end
    @notice  = notice ? NoticeDecorator.new(notice) : nil
    @comment = Comment.new
  end

  def show_by_id
    problem = Problem.find(params[:id])
    redirect_to app_problem_path(problem.app, problem)
  end

  def xhr_sparkline
    render partial: 'problems/sparkline', layout: false
  end

  def close_issue
    issue = Issue.new(problem: problem, user: current_user)
    flash[:error] = issue.errors.full_messages.join(', ') unless issue.close

    redirect_to app_problem_path(app, problem)
  end

  def create_issue
    issue = Issue.new(problem: problem, user: current_user)
    issue.body = render_to_string(*issue.render_body_args)

    flash[:error] = issue.errors.full_messages.join(', ') unless issue.save

    redirect_to app_problem_path(app, problem)
  end

  def unlink_issue
    problem.update_attribute :issue_link, nil
    redirect_to app_problem_path(app, problem)
  end

  def resolve
    problem.resolve!
    flash[:success] = t('.the_error_has_been_resolved')
    redirect_to :back
  rescue ActionController::RedirectBackError
    redirect_to app_path(app)
  end

  def resolve_several
    selected_problems.each(&:resolve!)
    flash[:success] = "Great news everyone! #{I18n.t(:n_errs_have, count: selected_problems.count)} #{I18n.t('n_errs_have.been_resolved')}."
    redirect_to :back
  end

  def unresolve_several
    selected_problems.each(&:unresolve!)
    flash[:success] = "#{I18n.t(:n_errs_have, count: selected_problems.count)} #{I18n.t('n_errs_have.been_unresolved')}."
    redirect_to :back
  end

  ##
  # Action to merge several Problem in One problem
  #
  # @param [ Array<String> ] :problems the list of problem ids
  #
  def merge_several
    if selected_problems.length < 2
      flash[:notice] = I18n.t('controllers.problems.flash.need_two_errors_merge')
    else
      ProblemMerge.new(selected_problems).merge
      flash[:notice] = I18n.t('controllers.problems.flash.merge_several.success', nb: selected_problems.count)
    end
    redirect_to :back
  end

  def unmerge_several
    all = selected_problems.flat_map(&:unmerge!)
    flash[:success] = "#{I18n.t(:n_errs_have, count: all.length)} #{I18n.t('n_errs_have.been_unmerged')}."
    redirect_to :back
  end

  def destroy_several
    DestroyProblemsByIdJob.perform_later(selected_problems_ids)
    flash[:notice] = "#{I18n.t(:n_errs, count: selected_problems.size)} #{I18n.t('n_errs.will_be_deleted')}."
    redirect_to :back
  end

  def destroy_all
    DestroyProblemsByAppJob.perform_later(app.id)
    flash[:success] = "#{I18n.t(:n_errs, count: app.problems.count)} #{I18n.t('n_errs.will_be_deleted')}."
    redirect_to :back
  rescue ActionController::RedirectBackError
    redirect_to app_path(app)
  end

  def search
    respond_to do |format|
      format.html { render :index }
      format.js
    end
  end

protected

  ##
  # Redirect :back if no errors selected
  #
  def need_selected_problem
    return if err_ids.any?

    flash[:notice] = I18n.t('controllers.problems.flash.no_select_problem')
    redirect_to :back
  end
end

app/helpers/problems_helper.rb
module ProblemsHelper
  def problem_confirm(action)
    t(format('problems.confirm.%s', action)) unless Errbit::Config.confirm_err_actions.eql? false
  end

  def gravatar_tag(email, options = {})
    return nil unless email.present?

    image_tag gravatar_url(email, options), alt: email, class: 'gravatar'
  end

  def gravatar_url(email, options = {})
    return nil unless email.present?

    default_options = {
      d: Errbit::Config.gravatar_default
    }
    options.reverse_merge! default_options
    params = options.extract!(:s, :d).delete_if { |_k, v| v.blank? }
    email_hash = Digest::MD5.hexdigest(email)
    url = request.ssl? ? "https://secure.gravatar.com" : "http://www.gravatar.com"
    "#{url}/avatar/#{email_hash}?#{params.to_query}"
  end
end

app/views/problems/_issue_tracker_links.html.haml
- if app.issue_tracker_configured?
  - tracker = app.issue_tracker
  - tracker_type = tracker.type
  - if problem.issue_link.present?
    %span
      = link_to problem.issue_link, :class => "goto-issue issue-tracker-button" do
        %img.button-icon{"src" => tracker_type.icons[:goto]}
        go to issue
    %span
      = link_to unlink_issue_app_problem_path(app, problem), :method => :delete, :data => { :confirm => "Unlink err issues?" }, :class => "unlink-issue issue-tracker-button" do
        %img.button-icon{"src" => tracker_type.icons[:create]}
        unlink issue
    - if tracker.tracker.respond_to? :close_issue
      %span
        = link_to close_issue_app_problem_path(app, problem), method: :post, :class => "close-issue" do
          %img.button-icon{"src" => tracker_type.icons[:create]}
          close issue
  - elsif problem.issue_link == "pending"
    %span.disabled
      = link_to '#', :class => "create-issue issue-tracker-button" do
        %img.button-icon{"src" => tracker_type.icons[:inactive]}
        creating...
    = link_to 'retry', create_issue_app_problem_path(app, problem), :method => :post
  - else
    %span
      = link_to create_issue_app_problem_path(app, problem), method: :post, :class => "create-issue issue-tracker-button" do
        %img.button-icon{"src" => tracker_type.icons[:create]}
        create issue

app/views/problems/_search.html.haml
= form_tag search_problems_path(:all_errs => all_errs, :app_id => app_id, :sort => params_sort, :order => params_order), :method => :get, :remote => true do
    = text_field_tag :search, params[:search], :placeholder => t('.search_placeholder')

app/views/problems/_sparkline.html.haml
= now = Time.current
%tr
  - two_week_percentages = problem.grouped_notice_count_relative_percentages((now - 13.days).at_beginning_of_day, 'day')
  - twenty_four_hour_percentages = problem.grouped_notice_count_relative_percentages((now - 23.hours).at_beginning_of_hour, 'hour')
  %th= t('.graph-2-weeks')
  %td= Sparklines.for_relative_percentages(two_week_percentages)
%tr
  %th= t('.graph (24 hours)')
  %td= Sparklines.for_relative_percentages(twenty_four_hour_percentages)

app/views/problems/_table.html.haml
- any_issue_links = problems.any?{|e| e.issue_link.present? && e.issue_link != 'pending' }
- on_page_that_can_include_multiple_different_apps = params[:controller] == 'problems'
=form_tag do
  %table.errs.selectable
    %thead
      %tr
        %th= check_box_tag "toggle_problems_checkboxes"
        - if on_page_that_can_include_multiple_different_apps
          %th= link_for_sort t('.app')
        - else
          %th= link_for_sort t('.env'), 'environment'
        %th= link_for_sort t('.what_&_where').html_safe, "message"
        %th= link_for_sort t('.latest'), "last_notice_at"
        %th.count-header= link_for_sort t('.count')
        - if any_issue_links
          %th Issue
        %th= t('.resolve')
    %tbody
      - ProblemDecorator.decorate_collection(problems).each do |problem|
        %tr{:class => problem.resolved? ? 'resolved' : 'unresolved'}
          %td.select.narrow-as-possible
            %div.td-container
              = check_box_tag "problems[]", problem.id, selected_problems.member?(problem.id.to_s)
          %td.app
            %div.td-container
              - if on_page_that_can_include_multiple_different_apps
                = link_to problem.app.name, app_path(problem.app), class: 'name nowrap', title: problem.app.name
                %span.environment{class: 'nowrap', title: problem.environment}
                  = link_to problem.environment, problems_path(:environment => problem.environment)
              - else
                %span.environment{class: 'nowrap', title: problem.environment}
                  = link_to problem.environment, app_path(problem.app, :environment => problem.environment)
          %td.message
            %div.td-container
              = link_to problem.link_text, app_problem_path(problem.app, problem), class: 'nowrap', title: problem.message
              %em{class: 'nowrap', title: problem.where}= problem.where
              - if problem.comments_count > 0
                - comment = problem.comments.last
                %br
                .inline_comment{class: 'nowrap'}
                  - if comment.user
                    %em.commenter= (Errbit::Config.user_has_username ? comment.user.username : comment.user.email).to_s << ":"
                  %em= truncate(comment.body, :length => 100, :separator => ' ')
          %td.latest
            - value = "#{time_ago_in_words(problem.last_notice_at)} #{I18n.t('problems.table.ago')}"
            %div.td-container{class: 'nowrap', title: value}= value
          %td.count.narrow-as-possible
            %div.td-container= link_to problem.notices_count, app_problem_path(problem.app, problem)
            - if any_issue_links
              %td.issue_link.narrow-as-possible
                - if problem.app.issue_tracker_configured? && problem.issue_link.present? && problem.issue_link != 'pending'
                  = link_to image_tag("#{problem.issue_type}_goto.png"), problem.issue_link, :target => "_blank"
          %td.resolve.narrow-as-possible
            %div.td-container= link_to image_tag("thumbs-up.png"), resolve_app_problem_path(problem.app, problem),
              :title => "Resolve", :method => :put, :data => { :confirm => problem_confirm('resolve_one') },
              :class => 'resolve' if problem.unresolved?
      - if problems.none?
        %tr
          %td{:colspan => 100}
            %em No errs here
  = paginate problems
  .tab-bar
    %ul
      - %w(merge unmerge resolve unresolve delete).each do |action|
        %li= submit_tag t(".#{action}").capitalize, :id => "#{action}_problems", :class => 'button',
          :data => { :action => polymorphic_path([action == 'delete' ? 'destroy' : action, 'several_problems']),
          :confirm => problem_confirm(action) }

app/views/problems/_tally_table.html.haml
.head_and_tail
  %table.tally.head
    %tbody
      - head(rows).each do |row|
        %tr
          %td.percent= number_to_percentage(row[0], :precision => 1)
          %th.value= row[1]
    - if rows.size > head_size
      %tfoot
        %tr
          %td{:colspan => 2}
            = link_to 'Show more...', '#', :class => :show_tail
  %table.tally.tail{:style => "display: none"}
    %tbody
      - tail(rows).each do |row|
        %tr
          %td.percent= number_to_percentage(row[0], :precision => 1)
          %th.value= row[1]

app/views/problems/index.html.haml
- content_for :title, all_errs ? t('.all_errors') : t('.unresolved_errors')
- content_for :head do
  = auto_discovery_link_tag :atom, problems_path(User.token_authentication_key => current_user.authentication_token, :format => "atom"), :title => "Errbit notices at #{request.host}"

- content_for :action_bar do
  - if all_errs
    = link_to t('.hide_resolved'), problems_path(sort: params_sort, order: params_order), :class => 'button'
  - else
    = link_to t('.show_resolved'), problems_path(all_errs: true, sort: params_sort, order: params_order), :class => 'button'

%section
  = render 'problems/search', :all_errs => all_errs, :app_id => nil
%br
%section
  #problem_table.problem_table
    = render 'problems/table'

app/views/problems/search.js.haml
$("#problem_table").empty().append("#{escape_javascript(render('problems/table', :problems => problems))}");
$("#flash-messages").empty();
toggleProblemsCheckboxes();
bindProblemButtonsActions();

app/views/problems/show.html.haml
- content_for :page_title, problem.message
- content_for :title_css_class, "err_show #{'resolved' if problem.resolved?}"
- content_for :title, problem.error_class || truncate(problem.message, :length => 32)
- content_for :meta do
  %strong= t('.app') + ':'
  = link_to app.name, app
  %strong= t('.where') + ':'
  = problem.where
  %br
  %strong= t('.environment') + ':'
  = problem.environment
  %strong= t('.first_notice') + ':'
  = problem.first_notice_at.to_s(:precise)
  %strong= t('.last_notice') + ':'
  = problem.last_notice_at.to_s(:precise)
- content_for :action_bar do
  - if problem.unresolved?
    %span= link_to t('.resolve'), [:resolve, app, problem], :method => :put,
      :data => { :confirm => problem_confirm('resolve_one') }, :class => 'resolve'
  - if current_user.authentication_token
    %span
      = link_to polymorphic_path([app, problem], :format => "ics", :auth_token => current_user.authentication_token) do
        %i.fa.fa-calendar
        iCal
  %span>= link_to t('.up'), (request.env['HTTP_REFERER'] ? :back : app_problems_path(app)), :class => 'up'
  %br
  = render "issue_tracker_links"

- content_for :comments do
  %h3= t('.comments')
  - problem.comments.ordered.each do |comment|
    .window
      %table.comment
        %tr
          %th
            - if comment.user
              - if Errbit::Config.use_gravatar
                = gravatar_tag comment.user.email, :s => 24
              %span.comment-info
                = time_ago_in_words(comment.created_at, include_seconds: true) << " " + t('.ago_by')
                = link_to comment.user.email, comment.user
            - else
              %span.comment-info
                = time_ago_in_words(comment.created_at, include_seconds: true) << " " + t('.ago_by_unknown_user')
            %span.delete= link_to '&#10008;'.html_safe, [app, problem, comment], :method => :delete,
              :data => { :confirm => t("comments.confirm_delete") }, :class => "destroy-comment"
        %tr
          %td= simple_format comment.body
  = form_for [app, problem, @comment] do |comment_form|
    %p= t('.add_a_comment')
    = comment_form.text_area :body
    = comment_form.submit t('.save_comment')

%h4= @notice.try(:message)

- if params[:notice_id]
  %p= t('.notice_by_id', notice_id: params[:notice_id])
- else
  = paginate @notices, :param_name => :notice, :theme => :notices

.tab-bar
  %ul
    %li= link_to t('.summary'), '#summary', :rel => 'summary', :class => 'button'
    %li= link_to t('.backtrace'), '#backtrace', :rel => 'backtrace', :class => 'button'
    - if @notice && @notice.user_attributes.present?
      %li= link_to t('.user'), '#user_attributes', :rel => 'user_attributes', :class => 'button'
    %li= link_to t('.environment'), '#environment', :rel => 'environment', :class => 'button'
    %li= link_to t('.parameters'), '#params', :rel => 'params', :class => 'button'
    %li= link_to t('.session'), '#session', :rel => 'session', :class => 'button'

- if @notice
  #summary
    %h3= t('.summary')
    = render 'notices/summary', :notice => @notice

  #backtrace
    %h3 Backtrace
    = render 'notices/backtrace', :backtrace => @notice.backtrace

  - if @notice.user_attributes.present?
    #user_attributes
      %h3 User
      = render 'notices/user_attributes', :user => @notice.user_attributes

  #environment
    %h3 Environment
    = render 'notices/environment', :notice => @notice

  #params
    %h3 Parameters
    = render 'notices/params', :notice => @notice

  #session
    %h3 Session
    = render 'notices/session', :notice => @notice

app/views/problems/show.ics.haml
= generate_problem_ical(problem.notices.object.order_by(:created_at.asc))